org.apache.http.client

## Interface HttpClient

- All Known Implementing Classes:
    AbstractHttpClient, AutoRetryHttpClient, CachingHttpClient, CloseableHttpClient, ContentEncodingHttpClient, DecompressingHttpClient, DefaultHttpClient, SystemDefaultHttpClient

      public interface HttpClient

  This interface represents only the most basic contract for HTTP request execution. It imposes no restrictions or particular details on the request execution process and leaves the specifics of state management, authentication and redirect handling up to individual implementations.
  Since:
    4.0

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `org.apache.http.HttpResponse` | `execute(org.apache.http.HttpHost target, org.apache.http.HttpRequest request)` Executes HTTP request using the default context.
    `org.apache.http.HttpResponse` | `execute(org.apache.http.HttpHost target, org.apache.http.HttpRequest request, org.apache.http.protocol.HttpContext context)` Executes HTTP request using the given context.
    `<T> T` | `execute(org.apache.http.HttpHost target, org.apache.http.HttpRequest request, ResponseHandler<? extends T> responseHandler)` Executes HTTP request to the target using the default context and processes the response using the given response handler.
    `<T> T` | `execute(org.apache.http.HttpHost target, org.apache.http.HttpRequest request, ResponseHandler<? extends T> responseHandler, org.apache.http.protocol.HttpContext context)` Executes HTTP request to the target using the given context and processes the response using the given response handler.
    `org.apache.http.HttpResponse` | `execute(HttpUriRequest request)` Executes HTTP request using the default context.
    `org.apache.http.HttpResponse` | `execute(HttpUriRequest request, org.apache.http.protocol.HttpContext context)` Executes HTTP request using the given context.
    `<T> T` | `execute(HttpUriRequest request, ResponseHandler<? extends T> responseHandler)` Executes HTTP request using the default context and processes the response using the given response handler.
    `<T> T` | `execute(HttpUriRequest request, ResponseHandler<? extends T> responseHandler, org.apache.http.protocol.HttpContext context)` Executes HTTP request using the given context and processes the response using the given response handler.
    `ClientConnectionManager` | `getConnectionManager()` Deprecated. (4.3) use `HttpClientBuilder`.
    `org.apache.http.params.HttpParams` | `getParams()` Deprecated. (4.3) use `RequestConfig`.

- - ### Method Detail

    - #### getParams

          @Deprecated
          org.apache.http.params.HttpParams getParams()

      Deprecated. (4.3) use `RequestConfig`.
      Obtains the parameters for this client. These parameters will become defaults for all requests being executed with this client, and for the parameters of dependent objects in this client.
      Returns:
        the default parameters

    - #### getConnectionManager

          @Deprecated
          ClientConnectionManager getConnectionManager()

      Deprecated. (4.3) use `HttpClientBuilder`.
      Obtains the connection manager used by this client.
      Returns:
        the connection manager

    - #### execute

          org.apache.http.HttpResponse execute(HttpUriRequest request)
                                               throws IOException,
                                                      ClientProtocolException

      Executes HTTP request using the default context.
      Parameters:
        `request` - the request to execute
      Returns:
        the response to the request. This is always a final response, never an intermediate response with an 1xx status code. Whether redirects or authentication challenges will be returned or handled automatically depends on the implementation and configuration of this client.
      Throws:
        `IOException` - in case of a problem or the connection was aborted
        `ClientProtocolException` - in case of an http protocol error

    - #### execute

          org.apache.http.HttpResponse execute(HttpUriRequest request,
                                             org.apache.http.protocol.HttpContext context)
                                               throws IOException,
                                                      ClientProtocolException

      Executes HTTP request using the given context.
      Parameters:
        `request` - the request to execute
        `context` - the context to use for the execution, or `null` to use the default context
      Returns:
        the response to the request. This is always a final response, never an intermediate response with an 1xx status code. Whether redirects or authentication challenges will be returned or handled automatically depends on the implementation and configuration of this client.
      Throws:
        `IOException` - in case of a problem or the connection was aborted
        `ClientProtocolException` - in case of an http protocol error

    - #### execute

          org.apache.http.HttpResponse execute(org.apache.http.HttpHost target,
                                             org.apache.http.HttpRequest request)
                                               throws IOException,
                                                      ClientProtocolException

      Executes HTTP request using the default context.
      Parameters:
        `target` - the target host for the request. Implementations may accept `null` if they can still determine a route, for example to a default target or by inspecting the request.
        `request` - the request to execute
      Returns:
        the response to the request. This is always a final response, never an intermediate response with an 1xx status code. Whether redirects or authentication challenges will be returned or handled automatically depends on the implementation and configuration of this client.
      Throws:
        `IOException` - in case of a problem or the connection was aborted
        `ClientProtocolException` - in case of an http protocol error

    - #### execute

          org.apache.http.HttpResponse execute(org.apache.http.HttpHost target,
                                             org.apache.http.HttpRequest request,
                                             org.apache.http.protocol.HttpContext context)
                                               throws IOException,
                                                      ClientProtocolException

      Executes HTTP request using the given context.
      Parameters:
        `target` - the target host for the request. Implementations may accept `null` if they can still determine a route, for example to a default target or by inspecting the request.
        `request` - the request to execute
        `context` - the context to use for the execution, or `null` to use the default context
      Returns:
        the response to the request. This is always a final response, never an intermediate response with an 1xx status code. Whether redirects or authentication challenges will be returned or handled automatically depends on the implementation and configuration of this client.
      Throws:
        `IOException` - in case of a problem or the connection was aborted
        `ClientProtocolException` - in case of an http protocol error

    - #### execute

          <T> T execute(HttpUriRequest request,
                      ResponseHandler<? extends T> responseHandler)
                    throws IOException,
                           ClientProtocolException

      Executes HTTP request using the default context and processes the response using the given response handler.

      Implementing classes are required to ensure that the content entity associated with the response is fully consumed and the underlying connection is released back to the connection manager automatically in all cases relieving individual `ResponseHandler`s from having to manage resource deallocation internally.

      Parameters:
        `request` - the request to execute
        `responseHandler` - the response handler
      Returns:
        the response object as generated by the response handler.
      Throws:
        `IOException` - in case of a problem or the connection was aborted
        `ClientProtocolException` - in case of an http protocol error

    - #### execute

          <T> T execute(HttpUriRequest request,
                      ResponseHandler<? extends T> responseHandler,
                      org.apache.http.protocol.HttpContext context)
                    throws IOException,
                           ClientProtocolException

      Executes HTTP request using the given context and processes the response using the given response handler.

      Implementing classes are required to ensure that the content entity associated with the response is fully consumed and the underlying connection is released back to the connection manager automatically in all cases relieving individual `ResponseHandler`s from having to manage resource deallocation internally.

      Parameters:
        `request` - the request to execute
        `responseHandler` - the response handler
        `context` - the context to use for the execution, or `null` to use the default context
      Returns:
        the response object as generated by the response handler.
      Throws:
        `IOException` - in case of a problem or the connection was aborted
        `ClientProtocolException` - in case of an http protocol error

    - #### execute

          <T> T execute(org.apache.http.HttpHost target,
                      org.apache.http.HttpRequest request,
                      ResponseHandler<? extends T> responseHandler)
                    throws IOException,
                           ClientProtocolException

      Executes HTTP request to the target using the default context and processes the response using the given response handler.

      Implementing classes are required to ensure that the content entity associated with the response is fully consumed and the underlying connection is released back to the connection manager automatically in all cases relieving individual `ResponseHandler`s from having to manage resource deallocation internally.

      Parameters:
        `target` - the target host for the request. Implementations may accept `null` if they can still determine a route, for example to a default target or by inspecting the request.
        `request` - the request to execute
        `responseHandler` - the response handler
      Returns:
        the response object as generated by the response handler.
      Throws:
        `IOException` - in case of a problem or the connection was aborted
        `ClientProtocolException` - in case of an http protocol error

    - #### execute

          <T> T execute(org.apache.http.HttpHost target,
                      org.apache.http.HttpRequest request,
                      ResponseHandler<? extends T> responseHandler,
                      org.apache.http.protocol.HttpContext context)
                    throws IOException,
                           ClientProtocolException

      Executes HTTP request to the target using the given context and processes the response using the given response handler.

      Implementing classes are required to ensure that the content entity associated with the response is fully consumed and the underlying connection is released back to the connection manager automatically in all cases relieving individual `ResponseHandler`s from having to manage resource deallocation internally.

      Parameters:
        `target` - the target host for the request. Implementations may accept `null` if they can still determine a route, for example to a default target or by inspecting the request.
        `request` - the request to execute
        `responseHandler` - the response handler
        `context` - the context to use for the execution, or `null` to use the default context
      Returns:
        the response object as generated by the response handler.
      Throws:
        `IOException` - in case of a problem or the connection was aborted
        `ClientProtocolException` - in case of an http protocol error

Copyright © 1999–2022 The Apache Software Foundation. All rights reserved.